diff -r 6f0361df1c82 django/core/files/uploadhandler.py
--- a/django/core/files/uploadhandler.py	Fri May 20 02:42:28 2011 +0000
+++ b/django/core/files/uploadhandler.py	Fri May 20 08:53:10 2011 +0200
@@ -84,7 +84,8 @@
         """
         pass
 
-    def new_file(self, field_name, file_name, content_type, content_length, charset=None):
+    def new_file(self, field_name, file_name, content_type, content_length,
+            charset=None, content_type_extra=None):
         """
         Signal that a new file has been started.
 
@@ -96,6 +97,9 @@
         self.content_type = content_type
         self.content_length = content_length
         self.charset = charset
+        if content_type_extra is None:
+            content_type_extra = {}
+        self.content_type_extra = content_type_extra
 
     def receive_data_chunk(self, raw_data, start):
         """
diff -r 6f0361df1c82 django/http/multipartparser.py
--- a/django/http/multipartparser.py	Fri May 20 02:42:28 2011 +0000
+++ b/django/http/multipartparser.py	Fri May 20 08:53:10 2011 +0200
@@ -171,8 +171,11 @@
                     file_name = self.IE_sanitize(unescape_entities(file_name))
 
                     content_type = meta_data.get('content-type', ('',))[0].strip()
+                    content_type_extra = meta_data.get('content-type', (0,{}))[1]
+                    if content_type_extra is None:
+                        content_type_extra = {}
                     try:
-                        charset = meta_data.get('content-type', (0,{}))[1].get('charset', None)
+                        charset = content_type_extra.get('charset', None)
                     except:
                         charset = None
 
@@ -187,7 +190,7 @@
                             try:
                                 handler.new_file(field_name, file_name,
                                                  content_type, content_length,
-                                                 charset)
+                                                 charset, content_type_extra.copy())
                             except StopFutureHandlers:
                                 break
 
diff -r 6f0361df1c82 django/test/client.py
--- a/django/test/client.py	Fri May 20 02:42:28 2011 +0000
+++ b/django/test/client.py	Fri May 20 08:53:10 2011 +0200
@@ -146,7 +146,10 @@
 
 def encode_file(boundary, key, file):
     to_str = lambda s: smart_str(s, settings.DEFAULT_CHARSET)
-    content_type = mimetypes.guess_type(file.name)[0]
+    if hasattr(file, 'content_type'):
+        content_type = file.content_type
+    else:
+        content_type = mimetypes.guess_type(file.name)[0]
     if content_type is None:
         content_type = 'application/octet-stream'
     return [
diff -r 6f0361df1c82 docs/topics/http/file-uploads.txt
--- a/docs/topics/http/file-uploads.txt	Fri May 20 02:42:28 2011 +0000
+++ b/docs/topics/http/file-uploads.txt	Fri May 20 08:53:10 2011 +0200
@@ -200,6 +200,11 @@
     For ``text/*`` content-types, the character set (i.e. ``utf8``) supplied
     by the browser. Again, "trust but verify" is the best policy here.
 
+.. attribute:: UploadedFile.content_type_extra
+
+    A dict containing the extra parameters that were passed to the
+    content-type header.
+
 .. attribute:: UploadedFile.temporary_file_path()
 
     Only files uploaded onto disk will have this method; it returns the full
@@ -357,7 +362,7 @@
 
         The default is 64*2\ :sup:`10` bytes, or 64 KB.
 
-    ``FileUploadHandler.new_file(self, field_name, file_name, content_type, content_length, charset)``
+    ``FileUploadHandler.new_file(self, field_name, file_name, content_type, content_length, charset, content_type_extra)``
         Callback signaling that a new file upload is starting. This is called
         before any data has been fed to any upload handlers.
 
@@ -374,6 +379,9 @@
         ``charset`` is the character set (i.e. ``utf8``) given by the browser.
         Like ``content_length``, this sometimes won't be provided.
 
+        ``content_type_extra`` is a dict containing the extra parameters that
+        were passed to the content-type header.
+
         This method may raise a ``StopFutureHandlers`` exception to prevent
         future handlers from handling this file.
 
diff -r 6f0361df1c82 tests/regressiontests/file_uploads/tests.py
--- a/tests/regressiontests/file_uploads/tests.py	Fri May 20 02:42:28 2011 +0000
+++ b/tests/regressiontests/file_uploads/tests.py	Fri May 20 08:53:10 2011 +0200
@@ -197,6 +197,16 @@
         got = simplejson.loads(response.content)
         self.assertTrue('f' not in got)
 
+    def test_extra_content_type(self):
+        f = tempfile.NamedTemporaryFile()
+        f.write('a' * (2 ** 21))
+        f.seek(0)
+        f.content_type = 'text/plain; blob-key=upload blob key; other=test'
+
+        response = self.client.post("/file_uploads/content_type_extra/", {'f': f})
+        got = simplejson.loads(response.content)
+        self.assertEqual(got['f'], 'upload blob key')
+
     def test_broken_custom_upload_handler(self):
         f = tempfile.NamedTemporaryFile()
         f.write('a' * (2 ** 21))
diff -r 6f0361df1c82 tests/regressiontests/file_uploads/uploadhandler.py
--- a/tests/regressiontests/file_uploads/uploadhandler.py	Fri May 20 02:42:28 2011 +0000
+++ b/tests/regressiontests/file_uploads/uploadhandler.py	Fri May 20 08:53:10 2011 +0200
@@ -2,7 +2,10 @@
 Upload handlers to test the upload API.
 """
 
-from django.core.files.uploadhandler import FileUploadHandler, StopUpload
+from django.core.files.uploadedfile import InMemoryUploadedFile
+from django.core.files.uploadhandler import (FileUploadHandler, StopUpload,
+    StopFutureHandlers)
+from StringIO import StringIO
 
 class QuotaUploadHandler(FileUploadHandler):
     """
@@ -32,3 +35,38 @@
     """A handler that raises an exception."""
     def receive_data_chunk(self, raw_data, start):
         raise CustomUploadError("Oops!")
+
+class ContentTypeExtraUploadHandler(FileUploadHandler):
+    """
+    File upload handler that handles content_type_extra
+    """
+
+    def new_file(self, *args, **kwargs):
+        super(ContentTypeExtraUploadHandler, self).new_file(*args, **kwargs)
+        self.blobkey = self.content_type_extra.get('blob-key', '')
+        self.file = StringIO()
+        self.file.write(self.blobkey)
+        self.active = self.blobkey is not None
+        if self.active:
+            raise StopFutureHandlers()
+
+    def receive_data_chunk(self, raw_data, start):
+        """
+        Add the data to the StringIO file.
+        """
+        if not self.active:
+            return raw_data
+
+    def file_complete(self, file_size):
+        if not self.active:
+            return
+
+        self.file.seek(0)
+        return InMemoryUploadedFile(
+            file = self.file,
+            field_name = self.field_name,
+            name = self.file_name,
+            content_type = self.content_type,
+            size = file_size,
+            charset = self.charset
+        )
diff -r 6f0361df1c82 tests/regressiontests/file_uploads/urls.py
--- a/tests/regressiontests/file_uploads/urls.py	Fri May 20 02:42:28 2011 +0000
+++ b/tests/regressiontests/file_uploads/urls.py	Fri May 20 08:53:10 2011 +0200
@@ -2,13 +2,14 @@
 import views
 
 urlpatterns = patterns('',
-    (r'^upload/$',          views.file_upload_view),
-    (r'^verify/$',          views.file_upload_view_verify),
-    (r'^unicode_name/$',    views.file_upload_unicode_name),
-    (r'^echo/$',            views.file_upload_echo),
-    (r'^echo_content/$',    views.file_upload_echo_content),
-    (r'^quota/$',           views.file_upload_quota),
-    (r'^quota/broken/$',    views.file_upload_quota_broken),
-    (r'^getlist_count/$',   views.file_upload_getlist_count),
-    (r'^upload_errors/$',   views.file_upload_errors),
+    (r'^upload/$',              views.file_upload_view),
+    (r'^verify/$',              views.file_upload_view_verify),
+    (r'^unicode_name/$',        views.file_upload_unicode_name),
+    (r'^echo/$',                views.file_upload_echo),
+    (r'^echo_content/$',        views.file_upload_echo_content),
+    (r'^quota/$',               views.file_upload_quota),
+    (r'^quota/broken/$',        views.file_upload_quota_broken),
+    (r'^getlist_count/$',       views.file_upload_getlist_count),
+    (r'^upload_errors/$',       views.file_upload_errors),
+    (r'^content_type_extra/$',  views.file_upload_content_type_extra),
 )
diff -r 6f0361df1c82 tests/regressiontests/file_uploads/views.py
--- a/tests/regressiontests/file_uploads/views.py	Fri May 20 02:42:28 2011 +0000
+++ b/tests/regressiontests/file_uploads/views.py	Fri May 20 08:53:10 2011 +0200
@@ -4,7 +4,8 @@
 from django.http import HttpResponse, HttpResponseServerError
 from django.utils import simplejson
 from models import FileModel, UPLOAD_TO
-from uploadhandler import QuotaUploadHandler, ErroringUploadHandler
+from uploadhandler import (QuotaUploadHandler, ErroringUploadHandler,
+    ContentTypeExtraUploadHandler)
 from tests import UNICODE_FILENAME
 
 def file_upload_view(request):
@@ -120,3 +121,8 @@
 def file_upload_errors(request):
     request.upload_handlers.insert(0, ErroringUploadHandler())
     return file_upload_echo(request)
+
+def file_upload_content_type_extra(request):
+    request.upload_handlers.insert(0, ContentTypeExtraUploadHandler())
+    r = dict([(k, f.read()) for k, f in request.FILES.items()])
+    return HttpResponse(simplejson.dumps(r))