diff --git a/django/core/management/commands/createcachetable.py b/django/core/management/commands/createcachetable.py
index 90172b6..a6628a0 100644
--- a/django/core/management/commands/createcachetable.py
+++ b/django/core/management/commands/createcachetable.py
@@ -18,7 +18,7 @@ class Command(LabelCommand):
     requires_model_validation = False
 
     def handle_label(self, tablename, **options):
-        alias = options.get('database', DEFAULT_DB_ALIAS)
+        alias = options.get('database')
         connection = connections[alias]
         fields = (
             # "key" is a reserved word in MySQL, so use "cache_key" instead.
diff --git a/django/core/management/commands/dbshell.py b/django/core/management/commands/dbshell.py
index a6b5427..7465920 100644
--- a/django/core/management/commands/dbshell.py
+++ b/django/core/management/commands/dbshell.py
@@ -16,7 +16,7 @@ class Command(BaseCommand):
     requires_model_validation = False
 
     def handle(self, **options):
-        connection = connections[options.get('database', DEFAULT_DB_ALIAS)]
+        connection = connections[options.get('database')]
         try:
             connection.client.runshell()
         except OSError:
diff --git a/django/core/management/commands/dumpdata.py b/django/core/management/commands/dumpdata.py
index 706bf60..162135a 100644
--- a/django/core/management/commands/dumpdata.py
+++ b/django/core/management/commands/dumpdata.py
@@ -30,14 +30,14 @@ class Command(BaseCommand):
     def handle(self, *app_labels, **options):
         from django.db.models import get_app, get_apps, get_models, get_model
 
-        format = options.get('format','json')
-        indent = options.get('indent',None)
-        using = options.get('database', DEFAULT_DB_ALIAS)
+        format = options.get('format')
+        indent = options.get('indent')
+        using = options.get('database')
         connection = connections[using]
-        excludes = options.get('exclude',[])
-        show_traceback = options.get('traceback', False)
-        use_natural_keys = options.get('use_natural_keys', False)
-        use_base_manager = options.get('use_base_manager', False)
+        excludes = options.get('exclude')
+        show_traceback = options.get('traceback')
+        use_natural_keys = options.get('use_natural_keys')
+        use_base_manager = options.get('use_base_manager')
 
         excluded_apps = set()
         excluded_models = set()
diff --git a/django/core/management/commands/flush.py b/django/core/management/commands/flush.py
index bcadb96..4eb329a 100644
--- a/django/core/management/commands/flush.py
+++ b/django/core/management/commands/flush.py
@@ -20,9 +20,9 @@ class Command(NoArgsCommand):
     help = "Executes ``sqlflush`` on the current database."
 
     def handle_noargs(self, **options):
-        db = options.get('database', DEFAULT_DB_ALIAS)
+        db = options.get('database')
         connection = connections[db]
-        verbosity = int(options.get('verbosity', 1))
+        verbosity = int(options.get('verbosity'))
         interactive = options.get('interactive')
 
         self.style = no_style()
diff --git a/django/core/management/commands/inspectdb.py b/django/core/management/commands/inspectdb.py
index e45f22c..27c4f0f 100644
--- a/django/core/management/commands/inspectdb.py
+++ b/django/core/management/commands/inspectdb.py
@@ -25,7 +25,7 @@ class Command(NoArgsCommand):
             raise CommandError("Database inspection isn't supported for the currently selected database backend.")
 
     def handle_inspection(self, options):
-        connection = connections[options.get('database', DEFAULT_DB_ALIAS)]
+        connection = connections[options.get('database')]
 
         table2model = lambda table_name: table_name.title().replace('_', '').replace(' ', '').replace('-', '')
 
diff --git a/django/core/management/commands/loaddata.py b/django/core/management/commands/loaddata.py
index 34f3543..2ca8db2 100644
--- a/django/core/management/commands/loaddata.py
+++ b/django/core/management/commands/loaddata.py
@@ -29,13 +29,13 @@ class Command(BaseCommand):
     )
 
     def handle(self, *fixture_labels, **options):
-        using = options.get('database', DEFAULT_DB_ALIAS)
+        using = options.get('database')
 
         connection = connections[using]
         self.style = no_style()
 
-        verbosity = int(options.get('verbosity', 1))
-        show_traceback = options.get('traceback', False)
+        verbosity = int(options.get('verbosity'))
+        show_traceback = options.get('traceback')
 
         # commit is a stealth option - it isn't really useful as
         # a command line option, but it can be useful when invoking
diff --git a/django/core/management/commands/reset.py b/django/core/management/commands/reset.py
index 475fd25..916af7f 100644
--- a/django/core/management/commands/reset.py
+++ b/django/core/management/commands/reset.py
@@ -20,7 +20,7 @@ class Command(AppCommand):
     output_transaction = True
 
     def handle_app(self, app, **options):
-        using = options.get('database', DEFAULT_DB_ALIAS)
+        using = options.get('database')
         connection = connections[using]
 
         app_name = app.__name__.split('.')[-2]
diff --git a/django/core/management/commands/runserver.py b/django/core/management/commands/runserver.py
index 892250f..4dac111 100644
--- a/django/core/management/commands/runserver.py
+++ b/django/core/management/commands/runserver.py
@@ -112,4 +112,4 @@ class Command(BaseRunserverCommand):
         Serves admin media like old-school (deprecation pending).
         """
         handler = super(Command, self).get_handler(*args, **options)
-        return AdminMediaHandler(handler, options.get('admin_media_path', ''))
+        return AdminMediaHandler(handler, options.get('admin_media_path'))
diff --git a/django/core/management/commands/sql.py b/django/core/management/commands/sql.py
index 582bc8e..59b2e77 100644
--- a/django/core/management/commands/sql.py
+++ b/django/core/management/commands/sql.py
@@ -16,4 +16,4 @@ class Command(AppCommand):
     output_transaction = True
 
     def handle_app(self, app, **options):
-        return u'\n'.join(sql_create(app, self.style, connections[options.get('database', DEFAULT_DB_ALIAS)])).encode('utf-8')
+        return u'\n'.join(sql_create(app, self.style, connections[options.get('database')])).encode('utf-8')
diff --git a/django/core/management/commands/sqlall.py b/django/core/management/commands/sqlall.py
index 8f3a38e..ab702bf 100644
--- a/django/core/management/commands/sqlall.py
+++ b/django/core/management/commands/sqlall.py
@@ -16,4 +16,4 @@ class Command(AppCommand):
     output_transaction = True
 
     def handle_app(self, app, **options):
-        return u'\n'.join(sql_all(app, self.style, connections[options.get('database', DEFAULT_DB_ALIAS)])).encode('utf-8')
+        return u'\n'.join(sql_all(app, self.style, connections[options.get('database')])).encode('utf-8')
diff --git a/django/core/management/commands/sqlclear.py b/django/core/management/commands/sqlclear.py
index c7e3a5e..b8f4913 100644
--- a/django/core/management/commands/sqlclear.py
+++ b/django/core/management/commands/sqlclear.py
@@ -16,4 +16,4 @@ class Command(AppCommand):
     output_transaction = True
 
     def handle_app(self, app, **options):
-        return u'\n'.join(sql_delete(app, self.style, connections[options.get('database', DEFAULT_DB_ALIAS)])).encode('utf-8')
+        return u'\n'.join(sql_delete(app, self.style, connections[options.get('database')])).encode('utf-8')
diff --git a/django/core/management/commands/sqlcustom.py b/django/core/management/commands/sqlcustom.py
index d206b04..6a98456 100644
--- a/django/core/management/commands/sqlcustom.py
+++ b/django/core/management/commands/sqlcustom.py
@@ -16,4 +16,4 @@ class Command(AppCommand):
     output_transaction = True
 
     def handle_app(self, app, **options):
-        return u'\n'.join(sql_custom(app, self.style, connections[options.get('database', DEFAULT_DB_ALIAS)])).encode('utf-8')
+        return u'\n'.join(sql_custom(app, self.style, connections[options.get('database')])).encode('utf-8')
diff --git a/django/core/management/commands/sqlflush.py b/django/core/management/commands/sqlflush.py
index 004f0a5..19054fb 100644
--- a/django/core/management/commands/sqlflush.py
+++ b/django/core/management/commands/sqlflush.py
@@ -16,4 +16,4 @@ class Command(NoArgsCommand):
     output_transaction = True
 
     def handle_noargs(self, **options):
-        return u'\n'.join(sql_flush(self.style, connections[options.get('database', DEFAULT_DB_ALIAS)], only_django=True)).encode('utf-8')
+        return u'\n'.join(sql_flush(self.style, connections[options.get('database')], only_django=True)).encode('utf-8')
diff --git a/django/core/management/commands/sqlindexes.py b/django/core/management/commands/sqlindexes.py
index c889f03..bf55b0d 100644
--- a/django/core/management/commands/sqlindexes.py
+++ b/django/core/management/commands/sqlindexes.py
@@ -17,4 +17,4 @@ class Command(AppCommand):
     output_transaction = True
 
     def handle_app(self, app, **options):
-        return u'\n'.join(sql_indexes(app, self.style, connections[options.get('database', DEFAULT_DB_ALIAS)])).encode('utf-8')
+        return u'\n'.join(sql_indexes(app, self.style, connections[options.get('database')])).encode('utf-8')
diff --git a/django/core/management/commands/sqlreset.py b/django/core/management/commands/sqlreset.py
index 13f40de..976b848 100644
--- a/django/core/management/commands/sqlreset.py
+++ b/django/core/management/commands/sqlreset.py
@@ -17,4 +17,4 @@ class Command(AppCommand):
     output_transaction = True
 
     def handle_app(self, app, **options):
-        return u'\n'.join(sql_reset(app, self.style, connections[options.get('database', DEFAULT_DB_ALIAS)])).encode('utf-8')
+        return u'\n'.join(sql_reset(app, self.style, connections[options.get('database')])).encode('utf-8')
diff --git a/django/core/management/commands/sqlsequencereset.py b/django/core/management/commands/sqlsequencereset.py
index aaab38b..6460f00 100644
--- a/django/core/management/commands/sqlsequencereset.py
+++ b/django/core/management/commands/sqlsequencereset.py
@@ -16,5 +16,5 @@ class Command(AppCommand):
     output_transaction = True
 
     def handle_app(self, app, **options):
-        connection = connections[options.get('database', DEFAULT_DB_ALIAS)]
+        connection = connections[options.get('database')]
         return u'\n'.join(connection.ops.sequence_reset_sql(self.style, models.get_models(app, include_auto_created=True))).encode('utf-8')
diff --git a/django/core/management/commands/syncdb.py b/django/core/management/commands/syncdb.py
index 3c11a26..5602246 100644
--- a/django/core/management/commands/syncdb.py
+++ b/django/core/management/commands/syncdb.py
@@ -22,9 +22,9 @@ class Command(NoArgsCommand):
 
     def handle_noargs(self, **options):
 
-        verbosity = int(options.get('verbosity', 1))
+        verbosity = int(options.get('verbosity'))
         interactive = options.get('interactive')
-        show_traceback = options.get('traceback', False)
+        show_traceback = options.get('traceback')
 
         self.style = no_style()
 
@@ -47,7 +47,7 @@ class Command(NoArgsCommand):
                 if not msg.startswith('No module named') or 'management' not in msg:
                     raise
 
-        db = options.get('database', DEFAULT_DB_ALIAS)
+        db = options.get('database')
         connection = connections[db]
         cursor = connection.cursor()
 
diff --git a/django/core/management/commands/test.py b/django/core/management/commands/test.py
index 1431f00..c4924ba 100644
--- a/django/core/management/commands/test.py
+++ b/django/core/management/commands/test.py
@@ -18,9 +18,9 @@ class Command(BaseCommand):
         from django.conf import settings
         from django.test.utils import get_runner
 
-        verbosity = int(options.get('verbosity', 1))
-        interactive = options.get('interactive', True)
-        failfast = options.get('failfast', False)
+        verbosity = int(options.get('verbosity'))
+        interactive = options.get('interactive')
+        failfast = options.get('failfast')
         TestRunner = get_runner(settings)
 
         if hasattr(TestRunner, 'func_name'):
diff --git a/django/core/management/commands/testserver.py b/django/core/management/commands/testserver.py
index d3d9698..b0ff768 100644
--- a/django/core/management/commands/testserver.py
+++ b/django/core/management/commands/testserver.py
@@ -19,8 +19,8 @@ class Command(BaseCommand):
         from django.core.management import call_command
         from django.db import connection
 
-        verbosity = int(options.get('verbosity', 1))
-        interactive = options.get('interactive', True)
+        verbosity = int(options.get('verbosity'))
+        interactive = options.get('interactive')
         addrport = options.get('addrport')
 
         # Create a test database.